# Derived from GitLab Docker template
# Official docker image.
image: docker:latest

stages:
  - build
  - publish

services:
  - docker:dind

before_script:
  - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
  - apk add -U bash

variables:
  DOCKER_DRIVER: overlay2
  PUBLISH_REGISTRY: quay.io
  PUBLISH_REGISTRY_NS: $PUBLISH_REGISTRY/ethanwu10

.build-template: &build
  stage: build
  script:
    - export TAG=$(echo "$CI_JOB_NAME" | cut -d ' ' -f 2)
    - ./build-variant.sh "$TAG"
    - export IMAGE="armv7hf-ros:$TAG"
    - docker tag "$IMAGE" "$CI_REGISTRY_IMAGE/$IMAGE"
    - docker push "$CI_REGISTRY_IMAGE/$IMAGE"
  only:
    - master

.publish-template: &publish
  stage: publish
  script:
    - docker login -u "$PUBLISH_REGISTRY_USER" -p "$PUBLISH_REGISTRY_PASS" "$PUBLISH_REGISTRY"
    - export TAG=$(echo "$CI_JOB_NAME" | cut -d ' ' -f 2)
    - export IMAGE="armv7hf-ros:$TAG"
    - docker pull "$CI_REGISTRY_IMAGE/$IMAGE"
    - docker tag "$CI_REGISTRY_IMAGE/$IMAGE" "$PUBLISH_REGISTRY_NS/$IMAGE"
    - docker push "$PUBLISH_REGISTRY_NS/$IMAGE"
  only:
    - master

build kinetic-ros-core: *build
publish kinetic-ros-core: *publish

build kinetic-ros-base: *build
publish kinetic-ros-base: *publish
